"""
Structured information about the launch of a computational process.
"""

# this file was auto-generated

from datetime import date, datetime
from fairgraph import KGObject, IRI
from fairgraph.fields import Field


class LaunchConfiguration(KGObject):
    """
    Structured information about the launch of a computational process.
    """

    default_space = "computation"
    type_ = ["https://openminds.ebrains.eu/computation/LaunchConfiguration"]
    context = {
        "schema": "http://schema.org/",
        "kg": "https://kg.ebrains.eu/api/instances/",
        "vocab": "https://openminds.ebrains.eu/vocab/",
        "terms": "https://openminds.ebrains.eu/controlledTerms/",
        "core": "https://openminds.ebrains.eu/core/",
    }
    fields = [
        Field(
            "name",
            str,
            "vocab:name",
            doc="Word or phrase that constitutes the distinctive designation of the launch configuration.",
        ),
        Field("arguments", str, "vocab:argument", multiple=True, doc="no description available"),
        Field(
            "description",
            str,
            "vocab:description",
            doc="Longer statement or account giving the characteristics of the launch configuration.",
        ),
        Field(
            "environment_variables",
            "openminds.core.PropertyValueList",
            "vocab:environmentVariable",
            doc="no description available",
        ),
        Field("executable", str, "vocab:executable", required=True, doc="no description available"),
    ]
    existence_query_fields = ("executable", "name")

    def __init__(
        self,
        name=None,
        arguments=None,
        description=None,
        environment_variables=None,
        executable=None,
        id=None,
        data=None,
        space=None,
        scope=None,
    ):
        return super().__init__(
            id=id,
            space=space,
            scope=scope,
            data=data,
            name=name,
            arguments=arguments,
            description=description,
            environment_variables=environment_variables,
            executable=executable,
        )
