"""

    Here we show the first 20 possible values, an additional 67 values are not shown.

    .. list-table:: **Possible values**
       :widths: 20 80
       :header-rows: 0

       * - `anterograde tracer <http://purl.obolibrary.org/obo/NLXMOL_1012002>`_
         - An anterograde tracer is a molecule that is taken up by neurons (e.g., by viral transfection mechanisms, by other cell internalization mechanisms or passive diffusion) and transported towards the axon terminals. It is used for anterograde tract tracing studies in the nervous system.
       * - `excitatory amino acid transporter 4 <http://purl.obolibrary.org/obo/PR_000014977>`_
         - The excitatory amino acid transporter 4 belongs to the EAAT familiy. It is expressed predominantly in the cerebellum, has high affinity for the excitatory amino acids L-aspartate and L-glutamate.
       * - `dopamine transporter <http://purl.obolibrary.org/obo/PR_000015188>`_
         - A 'dopamine transporter' is a membrane-spanning protein that pumps the neurotransmitter dopamine out of the synaptic cleft back into cytosol.
       * - `vesicular glutamate transporter 3 <http://purl.obolibrary.org/obo/PR_000014964>`_
         - The vesicular glutamate transporter 3 belongs to the VGLUT family. It transports the neurotransmitter glutamate into synaptic vesicles before it is released into the synaptic cleft.
       * - `calcium calmodulin protein kinase II <http://purl.obolibrary.org/obo/PR_000003197>`_
         - The 'calcium calmodulin protein kinase II' is a protein with a core domain architecture consisting of a Protein kinase domain and a C-terminal Calcium/calmodulin dependent protein kinase II Association domain.
       * - `growth factor <http://uri.neuinfo.org/nif/nifstd/sao1671627152>`_
         - The 'growth factor' comprises signal molecules that are involved in the control of cell growth and differentiation.
       * - `excitatory amino acid transporter 5 <http://purl.obolibrary.org/obo/PR_000014978>`_
         - The excitatory amino acid transporter 5 belongs to the EAAT familiy. It is expressed predominantly in the retina, has high affinity for the excitatory amino acid L-glutamate.
       * - `D1 receptor <http://uri.neuinfo.org/nif/nifstd/nifext_5845>`_
         - The D1 receptor is a subtype of the dopamine receptor group that primarily binds the neurotransmitter dopamine as endogenous ligand. The D1 receptor is the most abundant kind of dopamine receptor in the central nervous system.
       * - excitatory amino acid transporter
         - The excitatory amino acid transporters are a subclass of glutamate transporters that remove glutamate from the synaptic cleft and extrasynaptic sites via glutamate reuptake into glial cells and neurons.
       * - `lucifer yellow <http://id.nlm.nih.gov/mesh/2018/M0068243>`_
         - Lucifer yellow is a fluorescent dye used that it can be readily visualized in both living and fixed cells using a fluorescence microscope.
       * - `choline acetyltransferase <http://uri.neuinfo.org/nif/nifstd/sao722953401>`_
         - Choline acetyltransferase is a synthetic enzyme that catalyzes the formation of acetylcholine from acetyl-CoA and choline
       * - intrabody
         - An 'intrabody' is an antibody that works within the cell to bind an intracellular protein.
       * - `glutamate transporter <http://uri.neuinfo.org/nif/nifstd/sao1399894198>`_
         - The glutamate transporters are a class of transporter proteins that can move the neurotransmitter glutamate across membranes.
       * - brain-derived neurotrophic factor
         - The 'brain-derived neurotrophic factor' is a protein that, in humans, is encoded by the BDNF gene. [adapted from [wikipedia](https://en.wikipedia.org/wiki/Brain-derived_neurotrophic_factor)]
       * - `medetomidine <http://purl.obolibrary.org/obo/CHEBI_48552>`_
         - Medetomidine is a synthetic drug used as both a surgical anesthetic and analgesic.
       * - `calbindin <http://uri.neuinfo.org/nif/nifstd/nlx_mol_1006006>`_
         - Calbindin is a calcium-binding protein.
       * - `histamine <http://uri.neuinfo.org/nif/nifstd/nifext_5016>`_
         - Histamine is produced by basophils and mast cells (in connective tissues). It is involved in local immune responses and regulating physiological function in the gut and acts as a neurotransmitter (adapted from Wikipedia).
       * - `excitatory amino acid transporter 2 <http://purl.obolibrary.org/obo/PR_000014973>`_
         - The excitatory amino acid transporter 2 belongs to the EAAT familiy. It clears the excitatory neurotransmitter glutamate from the extracellular space at synapses in the central nervous system and is responsible for over 90% of glutamate reuptake within the brain.
       * - `isoflurane <http://purl.obolibrary.org/obo/CHEBI_6015>`_
         - Isoflurane is a stable, non-explosive inhalation anesthetic, relatively free from significant side effects.
       * - `5-HT1B receptor <http://uri.neuinfo.org/nif/nifstd/nifext_6386>`_
         - The 5-HT1B receptor is a subtype of serotonin receptor group (5-HT receptors) that bind the neurotransmitter serotonin (5-hydroxytryptamine, 5-HT).

"""

# this file was auto-generated

from datetime import date, datetime
from fairgraph import KGObject, IRI
from fairgraph.fields import Field


class MolecularEntity(KGObject):
    """

    Here we show the first 20 possible values, an additional 67 values are not shown.

    .. list-table:: **Possible values**
       :widths: 20 80
       :header-rows: 0

       * - `anterograde tracer <http://purl.obolibrary.org/obo/NLXMOL_1012002>`_
         - An anterograde tracer is a molecule that is taken up by neurons (e.g., by viral transfection mechanisms, by other cell internalization mechanisms or passive diffusion) and transported towards the axon terminals. It is used for anterograde tract tracing studies in the nervous system.
       * - `excitatory amino acid transporter 4 <http://purl.obolibrary.org/obo/PR_000014977>`_
         - The excitatory amino acid transporter 4 belongs to the EAAT familiy. It is expressed predominantly in the cerebellum, has high affinity for the excitatory amino acids L-aspartate and L-glutamate.
       * - `dopamine transporter <http://purl.obolibrary.org/obo/PR_000015188>`_
         - A 'dopamine transporter' is a membrane-spanning protein that pumps the neurotransmitter dopamine out of the synaptic cleft back into cytosol.
       * - `vesicular glutamate transporter 3 <http://purl.obolibrary.org/obo/PR_000014964>`_
         - The vesicular glutamate transporter 3 belongs to the VGLUT family. It transports the neurotransmitter glutamate into synaptic vesicles before it is released into the synaptic cleft.
       * - `calcium calmodulin protein kinase II <http://purl.obolibrary.org/obo/PR_000003197>`_
         - The 'calcium calmodulin protein kinase II' is a protein with a core domain architecture consisting of a Protein kinase domain and a C-terminal Calcium/calmodulin dependent protein kinase II Association domain.
       * - `growth factor <http://uri.neuinfo.org/nif/nifstd/sao1671627152>`_
         - The 'growth factor' comprises signal molecules that are involved in the control of cell growth and differentiation.
       * - `excitatory amino acid transporter 5 <http://purl.obolibrary.org/obo/PR_000014978>`_
         - The excitatory amino acid transporter 5 belongs to the EAAT familiy. It is expressed predominantly in the retina, has high affinity for the excitatory amino acid L-glutamate.
       * - `D1 receptor <http://uri.neuinfo.org/nif/nifstd/nifext_5845>`_
         - The D1 receptor is a subtype of the dopamine receptor group that primarily binds the neurotransmitter dopamine as endogenous ligand. The D1 receptor is the most abundant kind of dopamine receptor in the central nervous system.
       * - excitatory amino acid transporter
         - The excitatory amino acid transporters are a subclass of glutamate transporters that remove glutamate from the synaptic cleft and extrasynaptic sites via glutamate reuptake into glial cells and neurons.
       * - `lucifer yellow <http://id.nlm.nih.gov/mesh/2018/M0068243>`_
         - Lucifer yellow is a fluorescent dye used that it can be readily visualized in both living and fixed cells using a fluorescence microscope.
       * - `choline acetyltransferase <http://uri.neuinfo.org/nif/nifstd/sao722953401>`_
         - Choline acetyltransferase is a synthetic enzyme that catalyzes the formation of acetylcholine from acetyl-CoA and choline
       * - intrabody
         - An 'intrabody' is an antibody that works within the cell to bind an intracellular protein.
       * - `glutamate transporter <http://uri.neuinfo.org/nif/nifstd/sao1399894198>`_
         - The glutamate transporters are a class of transporter proteins that can move the neurotransmitter glutamate across membranes.
       * - brain-derived neurotrophic factor
         - The 'brain-derived neurotrophic factor' is a protein that, in humans, is encoded by the BDNF gene. [adapted from [wikipedia](https://en.wikipedia.org/wiki/Brain-derived_neurotrophic_factor)]
       * - `medetomidine <http://purl.obolibrary.org/obo/CHEBI_48552>`_
         - Medetomidine is a synthetic drug used as both a surgical anesthetic and analgesic.
       * - `calbindin <http://uri.neuinfo.org/nif/nifstd/nlx_mol_1006006>`_
         - Calbindin is a calcium-binding protein.
       * - `histamine <http://uri.neuinfo.org/nif/nifstd/nifext_5016>`_
         - Histamine is produced by basophils and mast cells (in connective tissues). It is involved in local immune responses and regulating physiological function in the gut and acts as a neurotransmitter (adapted from Wikipedia).
       * - `excitatory amino acid transporter 2 <http://purl.obolibrary.org/obo/PR_000014973>`_
         - The excitatory amino acid transporter 2 belongs to the EAAT familiy. It clears the excitatory neurotransmitter glutamate from the extracellular space at synapses in the central nervous system and is responsible for over 90% of glutamate reuptake within the brain.
       * - `isoflurane <http://purl.obolibrary.org/obo/CHEBI_6015>`_
         - Isoflurane is a stable, non-explosive inhalation anesthetic, relatively free from significant side effects.
       * - `5-HT1B receptor <http://uri.neuinfo.org/nif/nifstd/nifext_6386>`_
         - The 5-HT1B receptor is a subtype of serotonin receptor group (5-HT receptors) that bind the neurotransmitter serotonin (5-hydroxytryptamine, 5-HT).

    """

    default_space = "controlled"
    type_ = ["https://openminds.ebrains.eu/controlledTerms/MolecularEntity"]
    context = {
        "schema": "http://schema.org/",
        "kg": "https://kg.ebrains.eu/api/instances/",
        "vocab": "https://openminds.ebrains.eu/vocab/",
        "terms": "https://openminds.ebrains.eu/controlledTerms/",
        "core": "https://openminds.ebrains.eu/core/",
    }
    fields = [
        Field(
            "name",
            str,
            "vocab:name",
            required=True,
            doc="Word or phrase that constitutes the distinctive designation of the molecular entity.",
        ),
        Field(
            "definition",
            str,
            "vocab:definition",
            doc="Short, but precise statement of the meaning of a word, word group, sign or a symbol.",
        ),
        Field(
            "description",
            str,
            "vocab:description",
            doc="Longer statement or account giving the characteristics of the molecular entity.",
        ),
        Field(
            "interlex_identifier",
            IRI,
            "vocab:interlexIdentifier",
            doc="Persistent identifier for a term registered in the InterLex project.",
        ),
        Field(
            "knowledge_space_link",
            IRI,
            "vocab:knowledgeSpaceLink",
            doc="Persistent link to an encyclopedia entry in the Knowledge Space project.",
        ),
        Field(
            "preferred_ontology_identifier",
            IRI,
            "vocab:preferredOntologyIdentifier",
            doc="Persistent identifier of a preferred ontological term.",
        ),
        Field(
            "synonyms",
            str,
            "vocab:synonym",
            multiple=True,
            doc="Words or expressions used in the same language that have the same or nearly the same meaning in some or all senses.",
        ),
    ]
    existence_query_fields = ("name",)

    def __init__(
        self,
        name=None,
        definition=None,
        description=None,
        interlex_identifier=None,
        knowledge_space_link=None,
        preferred_ontology_identifier=None,
        synonyms=None,
        id=None,
        data=None,
        space=None,
        scope=None,
    ):
        return super().__init__(
            id=id,
            space=space,
            scope=scope,
            data=data,
            name=name,
            definition=definition,
            description=description,
            interlex_identifier=interlex_identifier,
            knowledge_space_link=knowledge_space_link,
            preferred_ontology_identifier=preferred_ontology_identifier,
            synonyms=synonyms,
        )
