"""

    Here we show the first 20 possible values, an additional 813 values are not shown.

    .. list-table:: **Possible values**
       :widths: 20 80
       :header-rows: 0

       * - `auditory cortex <http://purl.obolibrary.org/obo/UBERON_0001393>`_
         - The auditory cortex consists of neocortical areas that are functionally activated predominantly to sound, with the shortest latency.
       * - `uncinate fasciculus <http://purl.obolibrary.org/obo/UBERON_0003044>`_
         - 'Uncinate fasciculus' is a fasciculus of brain. It is part of the pontine tegmentum.
       * - `cortical amygdaloid nucleus <http://purl.obolibrary.org/obo/UBERON_0002891>`_
         - 'Cortical amygdaloid nucleus' is a telencephalic nucleus. It is part of the corticomedial nuclear complex.
       * - `cerebellar cortex <http://purl.obolibrary.org/obo/UBERON_0002129>`_
         - 'Cerebellar cortex' is a gray matter of hindbrain. It is part of the cerebellum.
       * - `transverse gyrus of Heschl <http://purl.obolibrary.org/obo/UBERON_0003939>`_
         - 'Transverse gyrus of Heschl' is a gyrus. It is part of the auditory cortex.
       * - `spinocerebellum <http://purl.obolibrary.org/obo/UBERON_0014643>`_
         - 'Spinocerebellum' is a regional part of brain. It is part of the cerebellum.
       * - `septal nuclear complex <http://purl.obolibrary.org/obo/UBERON_0002663>`_
         - 'Septal nuclear complex' is a cerebral hemisphere gray matter and nuclear complex of neuraxis. It is part of the septum of telencephalon and basal forebrain.
       * - `lateral superior olivary nucleus <http://purl.obolibrary.org/obo/UBERON_0002779>`_
         - 'Lateral superior olivary nucleus' is a nucleus of superior olivary complex. It is part of the primary superior olive.
       * - `lamina of septum pellucidum <http://purl.obolibrary.org/obo/UBERON_0002742>`_
         - 'Lamina of septum pellucidum' is a central nervous system cell part cluster and nervous system cell part layer. It is part of the septum pellucidum.
       * - `occipital cortex <http://purl.obolibrary.org/obo/UBERON_0016540>`_
         - 'Occipital cortex' is a cortex of cerebral lobe. It is part of the occipital lobe.
       * - `cephalopod optic lobe <http://purl.obolibrary.org/obo/UBERON_0006796>`_
         - 'Cephalopod optic lobe' is a visual processing part of nervous system. It is part of the brain.
       * - `choroid plexus of lateral ventricle <http://purl.obolibrary.org/obo/UBERON_0002307>`_
         - 'Choroid plexus of lateral ventricle' is a choroid plexus. It is part of the telencephalic ventricle.
       * - `medial globus pallidus <http://purl.obolibrary.org/obo/UBERON_0002477>`_
         - 'Medial globus pallidus' is a cerebral hemisphere gray matter. It is part of the globus pallidus.
       * - `brain ependyma <http://purl.obolibrary.org/obo/UBERON_0005357>`_
         - 'Brain ependyma' is an ependyma. It is part of the brain ventricle.
       * - `superior temporal sulcus <http://purl.obolibrary.org/obo/UBERON_0002734>`_
         - The 'superior temporal sulcus' is the sulcus separating the superior temporal gyrus from the middle temporal gyrus in the temporal lobe of the brain. [from [wikipedia](http://en.wikipedia.org/wiki/Superior_temporal_sulcus)]
       * - `dorsal raphe nucleus <http://purl.obolibrary.org/obo/UBERON_0002043>`_
         - 'Dorsal raphe nucleus' is a nucleus of midbrain reticular formation. It is part of the raphe nuclei.
       * - `rhombic lip <http://purl.obolibrary.org/obo/UBERON_0006215>`_
         - 'Rhombic lip' is part of the future metencephalon.
       * - `lentiform nucleus <http://purl.obolibrary.org/obo/UBERON_0002263>`_
         - 'Lentiform nucleus' is a telencephalic nucleus. It is part of the ventral striatum.
       * - `temporal cortex cingulum <http://purl.obolibrary.org/obo/UBERON_0022429>`_
         - The 'temporal cortex cingulum' is a white matter fibre bundle. It is part of cingulum of brain.
       * - `white matter lamina of cerebellum <http://purl.obolibrary.org/obo/UBERON_0014540>`_
         - 'White matter lamina of cerebellum' is a white matter lamina of neuraxis. It is part of the cerebellum.

"""

# this file was auto-generated

from datetime import date, datetime
from fairgraph import KGObject, IRI
from fairgraph.fields import Field


class UBERONParcellation(KGObject):
    """

    Here we show the first 20 possible values, an additional 813 values are not shown.

    .. list-table:: **Possible values**
       :widths: 20 80
       :header-rows: 0

       * - `auditory cortex <http://purl.obolibrary.org/obo/UBERON_0001393>`_
         - The auditory cortex consists of neocortical areas that are functionally activated predominantly to sound, with the shortest latency.
       * - `uncinate fasciculus <http://purl.obolibrary.org/obo/UBERON_0003044>`_
         - 'Uncinate fasciculus' is a fasciculus of brain. It is part of the pontine tegmentum.
       * - `cortical amygdaloid nucleus <http://purl.obolibrary.org/obo/UBERON_0002891>`_
         - 'Cortical amygdaloid nucleus' is a telencephalic nucleus. It is part of the corticomedial nuclear complex.
       * - `cerebellar cortex <http://purl.obolibrary.org/obo/UBERON_0002129>`_
         - 'Cerebellar cortex' is a gray matter of hindbrain. It is part of the cerebellum.
       * - `transverse gyrus of Heschl <http://purl.obolibrary.org/obo/UBERON_0003939>`_
         - 'Transverse gyrus of Heschl' is a gyrus. It is part of the auditory cortex.
       * - `spinocerebellum <http://purl.obolibrary.org/obo/UBERON_0014643>`_
         - 'Spinocerebellum' is a regional part of brain. It is part of the cerebellum.
       * - `septal nuclear complex <http://purl.obolibrary.org/obo/UBERON_0002663>`_
         - 'Septal nuclear complex' is a cerebral hemisphere gray matter and nuclear complex of neuraxis. It is part of the septum of telencephalon and basal forebrain.
       * - `lateral superior olivary nucleus <http://purl.obolibrary.org/obo/UBERON_0002779>`_
         - 'Lateral superior olivary nucleus' is a nucleus of superior olivary complex. It is part of the primary superior olive.
       * - `lamina of septum pellucidum <http://purl.obolibrary.org/obo/UBERON_0002742>`_
         - 'Lamina of septum pellucidum' is a central nervous system cell part cluster and nervous system cell part layer. It is part of the septum pellucidum.
       * - `occipital cortex <http://purl.obolibrary.org/obo/UBERON_0016540>`_
         - 'Occipital cortex' is a cortex of cerebral lobe. It is part of the occipital lobe.
       * - `cephalopod optic lobe <http://purl.obolibrary.org/obo/UBERON_0006796>`_
         - 'Cephalopod optic lobe' is a visual processing part of nervous system. It is part of the brain.
       * - `choroid plexus of lateral ventricle <http://purl.obolibrary.org/obo/UBERON_0002307>`_
         - 'Choroid plexus of lateral ventricle' is a choroid plexus. It is part of the telencephalic ventricle.
       * - `medial globus pallidus <http://purl.obolibrary.org/obo/UBERON_0002477>`_
         - 'Medial globus pallidus' is a cerebral hemisphere gray matter. It is part of the globus pallidus.
       * - `brain ependyma <http://purl.obolibrary.org/obo/UBERON_0005357>`_
         - 'Brain ependyma' is an ependyma. It is part of the brain ventricle.
       * - `superior temporal sulcus <http://purl.obolibrary.org/obo/UBERON_0002734>`_
         - The 'superior temporal sulcus' is the sulcus separating the superior temporal gyrus from the middle temporal gyrus in the temporal lobe of the brain. [from [wikipedia](http://en.wikipedia.org/wiki/Superior_temporal_sulcus)]
       * - `dorsal raphe nucleus <http://purl.obolibrary.org/obo/UBERON_0002043>`_
         - 'Dorsal raphe nucleus' is a nucleus of midbrain reticular formation. It is part of the raphe nuclei.
       * - `rhombic lip <http://purl.obolibrary.org/obo/UBERON_0006215>`_
         - 'Rhombic lip' is part of the future metencephalon.
       * - `lentiform nucleus <http://purl.obolibrary.org/obo/UBERON_0002263>`_
         - 'Lentiform nucleus' is a telencephalic nucleus. It is part of the ventral striatum.
       * - `temporal cortex cingulum <http://purl.obolibrary.org/obo/UBERON_0022429>`_
         - The 'temporal cortex cingulum' is a white matter fibre bundle. It is part of cingulum of brain.
       * - `white matter lamina of cerebellum <http://purl.obolibrary.org/obo/UBERON_0014540>`_
         - 'White matter lamina of cerebellum' is a white matter lamina of neuraxis. It is part of the cerebellum.

    """

    default_space = "controlled"
    type_ = ["https://openminds.ebrains.eu/controlledTerms/UBERONParcellation"]
    context = {
        "schema": "http://schema.org/",
        "kg": "https://kg.ebrains.eu/api/instances/",
        "vocab": "https://openminds.ebrains.eu/vocab/",
        "terms": "https://openminds.ebrains.eu/controlledTerms/",
        "core": "https://openminds.ebrains.eu/core/",
    }
    fields = [
        Field(
            "name",
            str,
            "vocab:name",
            required=True,
            doc="Word or phrase that constitutes the distinctive designation of the UBERONParcellation.",
        ),
        Field(
            "definition",
            str,
            "vocab:definition",
            doc="Short, but precise statement of the meaning of a word, word group, sign or a symbol.",
        ),
        Field(
            "description",
            str,
            "vocab:description",
            doc="Longer statement or account giving the characteristics of the UBERONParcellation.",
        ),
        Field(
            "interlex_identifier",
            IRI,
            "vocab:interlexIdentifier",
            doc="Persistent identifier for a term registered in the InterLex project.",
        ),
        Field(
            "knowledge_space_link",
            IRI,
            "vocab:knowledgeSpaceLink",
            doc="Persistent link to an encyclopedia entry in the Knowledge Space project.",
        ),
        Field(
            "preferred_ontology_identifier",
            IRI,
            "vocab:preferredOntologyIdentifier",
            doc="Persistent identifier of a preferred ontological term.",
        ),
        Field(
            "synonyms",
            str,
            "vocab:synonym",
            multiple=True,
            doc="Words or expressions used in the same language that have the same or nearly the same meaning in some or all senses.",
        ),
    ]
    existence_query_fields = ("name",)

    def __init__(
        self,
        name=None,
        definition=None,
        description=None,
        interlex_identifier=None,
        knowledge_space_link=None,
        preferred_ontology_identifier=None,
        synonyms=None,
        id=None,
        data=None,
        space=None,
        scope=None,
    ):
        return super().__init__(
            id=id,
            space=space,
            scope=scope,
            data=data,
            name=name,
            definition=definition,
            description=description,
            interlex_identifier=interlex_identifier,
            knowledge_space_link=knowledge_space_link,
            preferred_ontology_identifier=preferred_ontology_identifier,
            synonyms=synonyms,
        )
