import sys
import inspect
from fairgraph.kgobject import KGObject

from .activity.recording_activity import RecordingActivity
from .activity.electrode_placement import ElectrodePlacement
from .activity.cell_patching import CellPatching
from .entity.channel import Channel
from .entity.recording import Recording
from .device.electrode_array import ElectrodeArray
from .device.pipette_usage import PipetteUsage
from .device.pipette import Pipette
from .device.electrode import Electrode
from .device.electrode_usage import ElectrodeUsage
from .device.electrode_array_usage import ElectrodeArrayUsage


def list_kg_classes():
    """List all KG classes defined in this module"""
    return [
        obj
        for name, obj in inspect.getmembers(sys.modules[__name__])
        if inspect.isclass(obj) and issubclass(obj, KGObject) and obj.__module__.startswith(__name__)
    ]
